import { Injectable } from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams, HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from '../../../../environments/environment.development';
import { JobModel } from '../model/jobModel.model';


@Injectable({
  providedIn: 'root',
})
export class JobService {
  apiUrl = environment.API_DOMAIN + '/jobs';
  apiUrlById = environment.API_DOMAIN + '/jobById';
  constructor(private http: HttpClient) {}

  jobsGet(): Observable<any> {
    const params = new HttpParams()
    return this.http.get<any>(this.apiUrl, { params });
  }
  addingNewJob(data: JobModel): Observable<any> {
    const headers = new HttpHeaders()
      .set('Content-Type', 'application/json')
      .set('authorization', `Bearer ${localStorage.getItem('token')}`);
    return this.http.post<any>(this.apiUrl, data, { headers });
  }
  deleteJob(id: string): Observable<any> {
    const headers = new HttpHeaders()
      .set('Content-Type', 'application/json')
      .set('Authorization', `Bearer ${localStorage.getItem('token')}`);
    const url = `${this.apiUrl}/${id}`;
    return this.http.delete<any>(url, { headers });
  }
  editJob(data: JobModel): Observable<any> {
    const headers = new HttpHeaders()
      .set('Content-Type', 'application/json')
      .set('Authorization', `Bearer ${localStorage.getItem('token')}`);
    const url = `${this.apiUrl}/${data.id}`;
    return this.http.put<any>(url, data, { headers });
  }
  getJob(id: string): Observable<any> {
    const headers = new HttpHeaders()
      .set('Content-Type', 'application/json')
      .set('Authorization', `Bearer ${localStorage.getItem('token')}`);
    const url = `${this.apiUrlById}/${id}`;
    console.log(id, url);
    return this.http.get<any>(url, { headers });
  }

}
